package com.qima.gift.appcommon.account.authc;

import com.qima.gift.appcommon.account.AccountConst;
import com.qima.gift.appcommon.account.bean.AccountAuth;
import com.qima.gift.appcommon.account.bean.AccountInfoBO;
import com.qima.gift.appcommon.account.service.IAccountService;
import com.qima.gift.appcommon.wechat.service.IWeChatService;
import jakarta.annotation.PostConstruct;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.context.annotation.ScopedProxyMode;
import org.springframework.stereotype.Component;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/6/6 19:12
 */
@Component
@Scope(proxyMode = ScopedProxyMode.NO)
public class UserNameAccountAuthc implements IAccountAuthc{

    @Autowired
    private IAccountService accountService;

    @PostConstruct
    protected void init() {
        accountService.registIAccountAuth(this);
    }

    @Override
    public Authentication doAuth(Authentication custom, IAuthEncode encode) {
        AccountInfoBO bo = accountService.findAccountByPrincipal(support(), custom.getPrincipal());
        if(bo == null) {
//            if("auto123456".equals(custom.getCredentials())){
//                // TODO 完成自动注册（临时代码，后面删除）
//                bo = accountService.createAccount(support(), custom.getPrincipal(), custom.getCredentials());
//                custom.setAccountAuthTypeEnum(support());
//                custom.setAccountInfoId(bo.getAccountInfoBean().getId());
//                custom.setUsed(true);
//            } else {
//                custom.setUsed(false);
//            }
            custom.setUsed(false);
        } else {
            AccountAuth auth = bo.findAccountAuthByType(support());
            if(auth.getCredentials().equals(custom.getCredentials())) {
                custom.setAccountAuthTypeEnum(support());
                custom.setAccountInfoId(bo.getAccountInfoBean().getId());
                custom.setUsed(true);
            } else {
                custom.setUsed(false);
            }
        }
        return custom;
    }

    @Override
    public AccountConst.AccountAuthTypeEnum support() {
        return AccountConst.AccountAuthTypeEnum.UserName;
    }
}
