package com.qima.gift.appcommon.account.bean;

import com.google.common.collect.Lists;
import com.qima.gift.appcommon.account.AccountConst;
import com.qima.gift.common.utils.ObjectUtils;

import java.util.List;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/6/4 19:05
 */
public class AccountInfoBO {

    private AccountInfo accountInfoBean;

    private List<AccountAuth> accountAuthBeans = Lists.newArrayList();

    public AccountInfoBO(AccountInfo accountInfoBean) {
        this.accountInfoBean = accountInfoBean;
    }

    public AccountInfo getAccountInfoBean() {
        return accountInfoBean;
    }

    public List<AccountAuth> getAccountAuthBeans() {
        return accountAuthBeans;
    }

    public void addAccountAuthBean(AccountAuth bean) {
        accountAuthBeans.add(bean);
    }

    public boolean hasAuthType(AccountConst.AccountAuthTypeEnum e) {
        return ObjectUtils.isNotNull(findAccountAuthByType(e));
    }

    public AccountAuth findAccountAuthByType(AccountConst.AccountAuthTypeEnum e) {
        AccountAuth r = accountAuthBeans.stream().filter(b->e.getKey().equals(b.getAuthType())).findFirst().orElse(null);
        return r;
    }

}
