package com.qima.gift.appcommon.security.satoken;

import com.google.common.collect.Maps;
import lombok.Data;

import java.util.Map;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/6/11 20:06
 */
@Data
public class LoginDataDTO {
    private String satoken;
    private String accountId;
    private String phone;
    // 按照模块和账户关联的需要加载的信息
    private Map<String,Object> attr = Maps.newLinkedHashMap();

    public Object setAttr(String key,Object obj) {
        return attr.put(key, obj);
    }

    public <T> T getAttr(String key) {
        return (T)attr.get(key);
    }

    public static LoginDataDTO build(String a, String t) {
        return build(a, null, t);
    }

    public static LoginDataDTO build(String a,String p,String t) {
        LoginDataDTO r = new LoginDataDTO();
        r.setAccountId(a);
        r.setPhone(p);
        r.setSatoken(t);
        return r;
    }
}
