package com.qima.gift.appcommon.wechat.service;

import com.qima.gift.appcommon.wechat.bean.AbsWeChatBean;
import com.qima.gift.appcommon.wechat.bean.GetPhoneNumber;
import com.qima.gift.appcommon.wechat.bean.WeChatConfigBean;
import com.qima.gift.common.AppException;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/6/3 20:16
 */
public interface IWeChatService {

    /**
     * 获取配置信息
     * @return 配置
     */
    public WeChatConfigBean findConfig();

    /**
     * 获取凭证
     * @return 有效凭证
     */
    public String findAccessToken() throws AppException;

    /**
     * 登录
     * @param jsCode 前端登录code
     * @return 用户唯一码
     * @throws AppException
     */
    public String code2Session(String jsCode) throws AppException;

    /**
     * 获取手机号
     * @param code 授权码
     * @return 电话
     * @throws AppException
     */
    public String getPhoneNumber(String code) throws AppException;

    /**
     * 调用微信接口
     * @param i 接口对象，返回值填充到res中
     */
    public <Q,S> void callWeChat(AbsWeChatBean<Q,S> i) throws AppException;

}
