package com.qima.gift.common.utils;

import com.esotericsoftware.kryo.Kryo;
import com.qima.gift.mall.bean.MallGoodsSku;
import com.qima.gift.mall.bean.MallShow;
import com.qima.gift.mall.bean.MallShowBO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.cglib.beans.BeanCopier;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.concurrent.ConcurrentHashMap;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/6/2 16:42
 */
@Slf4j
public class ObjectUtils {

    private static ThreadLocal<Kryo> kryoThreadLocal = new ThreadLocal<Kryo>();

    private ObjectUtils(){}

    public static boolean isAnyNull(Object... os) {
        if(os == null) {
            return true;
        } else {
            for(Object o:os) {
                if(o == null) {
                    return true;
                }
            }
            return false;
        }
    }

    public static boolean isNotNull(Object... os) {
        return !isAnyNull(os);
    }

    public static <T> T copyObject(T obj) {
        return obj == null?null:getKryo(obj.getClass()).copy(obj);
    }

    protected static Kryo getKryo(Class c) {
        Kryo r = kryoThreadLocal.get();
        if(r == null) {
            r = new Kryo();
            r.setRegistrationRequired(false);
            kryoThreadLocal.set(r);
        }
        r.register(c);
        return r;
    }

    private static void doCopy(boolean out) {
        MallShowBO source = new MallShowBO(new MallShow());
        source.getMallShow().setId("1");
        source.getMallGoodsSkus().add(new MallGoodsSku());
        MallShowBO target = copyObject(source);
        if(out) {
            System.out.println(source.equals(target));
            System.out.println(source == target);
            System.out.println(source.getMallShow().equals(target.getMallShow()));
            System.out.println(source.getMallShow() == target.getMallShow());
            System.out.println(source.getMallShow().getId().equals(target.getMallShow().getId()));
            System.out.println(source.getMallShow().getId().equals(target.getMallShow().getId()));
            System.out.println(source.getMallGoodsSkus().size());
            System.out.println(target.getMallGoodsSkus().size());
        }
    }

    public static void main(String[] args) {
        long s = System.currentTimeMillis();
        for(int i = 0 ;i<10000;i++) {
            doCopy(false);
        }
        long e = System.currentTimeMillis();
        System.out.println("时间消耗"+ (e-s));
    }

}
