package com.qima.gift.mall.bean;

import com.google.common.collect.Lists;
import lombok.Data;

import java.util.List;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/6/14 16:22
 */
@Data
public class MallMerchantBO {

    private MallMerchant mallMerchant;
    private List<MallMerchantMember> mallMerchantMembers = Lists.newArrayList();

    public MallMerchantBO() {}
    public MallMerchantBO(MallMerchant bean) {
        mallMerchant = bean;
    }

    /** 方法区 **/
    public MallMerchantMember findMemberById(String memId) {
        for(MallMerchantMember m:mallMerchantMembers) {
            if(m.getId().equals(memId)) {
                return m;
            }
        }
        return null;
    }

    public MallMerchantMember findOwner() {
        return findMemberById(mallMerchant.getOwner());
    }

    public MallMerchantMember findMemberByAccountId(String accountId) {
        for(MallMerchantMember m:mallMerchantMembers) {
            if(m.getAccountId().equals(accountId)) {
                return m;
            }
        }
        return null;
    }

}
